Unit ArmV1Un;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, math, StdCtrls, Spin, ExtCtrls, ComCtrls;

type
  TArmV1Fm = class(TForm)
    Panel1: TPanel;
    RESET: TButton;
    ExitBut: TButton;
    SetTargPos: TImage;
    SetViewAngle: TImage;
    TrackBar1: TTrackBar;
    Label1: TLabel;
    EditParazms: TButton;
    Panel2: TPanel;
    TrackBar2: TTrackBar;
    TrackBar3: TTrackBar;
    TrackBar4: TTrackBar;
    TrackBar5: TTrackBar;
    TrackBar6: TTrackBar;
    TrackBar7: TTrackBar;
    TrackBar8: TTrackBar;
    TrackBar9: TTrackBar;
    TrackBar10: TTrackBar;
    TrackBar11: TTrackBar;
    TrackBar12: TTrackBar;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    TrackBar13: TTrackBar;
    TrackBar14: TTrackBar;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure RESETClick(Sender: TObject);
    procedure ExitButClick(Sender: TObject);
    procedure setxypos(Sender: TObject; Shift: TShiftState; X,Y: Integer);
    procedure setViewpoint(Sender: TObject; Shift: TShiftState; X,Y: Integer);
    procedure TrackBar1Change(Sender: TObject);
    procedure EditParazmsClick(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure TrackBar4Change(Sender: TObject);
    procedure TrackBar5Change(Sender: TObject);
    procedure TrackBar6Change(Sender: TObject);
    procedure TrackBar7Change(Sender: TObject);
    procedure TrackBar8Change(Sender: TObject);
    procedure TrackBar9Change(Sender: TObject);
    procedure TrackBar12Change(Sender: TObject);
    procedure TrackBar13Change(Sender: TObject);
    procedure TrackBar10Change(Sender: TObject);
    procedure TrackBar11Change(Sender: TObject);
    procedure TrackBar14Change(Sender: TObject);
    procedure saveparams(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  procedure IdleLoop(Sender: TObject; var Done: boolean);
 end; { of public declarations}

const clBackgnd = clWhite;
      clWrite = clBlack;

type   poly2dtype = array[1..50] of
                record
                  x2d,y2d: integer;
                 end;

function getmaxx: integer;
function getmaxy: integer;
procedure setviewport(x1,y1,x2,y2: integer);
procedure clearviewport;
procedure outtextxy(x,y: integer; s: string);
procedure outtextxy1(x,y: integer; s: string);
procedure textattr(c: byte);
procedure gotoxy(x,y: integer);
procedure clrscr;
procedure setwritemode(m: integer);
procedure setpencolor(c: integer);
procedure setbrushcolor(c: integer);
procedure setfontcolor(c: integer);
procedure drawpoly(n: integer; var v: poly2dtype);
function wherex: integer;
function wherey: integer;
function readkey: byte;
procedure writestr(s: string);
procedure writelnstr(s: string);
procedure putpixel(x,y: integer; c: byte);
procedure delay(t: smallint);
procedure loaddiagram;
procedure loadedit(var g2a,g2b,g2c,g1a,s1a,g1b,s1b,g1c,s1c,g1d,s1d,g1e,s1e: integer);

var
  ArmV1Fm: TArmV1Fm;
  viewport: TRect;
  pmode: TPenmode;
  bcolor: Tcolor;
  pcolor: Tcolor;
  fcolor: TColor;
  cwidth,leading: integer;
  inkey: word;
  keyhit: boolean;

implementation
{$R *.dfm}

uses TPUnit;

var t1,t2,freq: int64;


procedure loaddiagram;
var bitmap1: TBitmap;
begin
 bitmap1 := TBitmap.create;
 bitmap1.width := 440;
 bitmap1.Height := 360;
 bitmap1.loadfromfile('diagram.bmp');
with armv1fm do
  begin
   canvas.draw(0,0,bitmap1);
   visible := true;
  end;
end;

procedure delay(t: smallint);
var t3,t4: int64;
begin
 queryperformancecounter(t3);
 repeat
  application.processmessages;
  queryperformancecounter(t4);
 until t4 - t3 >= t*freq/10000;
end;

{$R-}
function editnumok(s:string): boolean;
var t,code: integer;
begin
 val(s,t,code);
 editnumok := code = 0;
end;


procedure showedit;
begin
 with armv1fm do
 begin
  label15.caption := inttostr(g2a);
  label16.caption := inttostr(g2b);
  label17.caption := inttostr(g2c);
  label18.caption := inttostr(g1a);
  label19.caption := inttostr(s1a);
  label20.caption := inttostr(g1b);
  label21.caption := inttostr(s1b);
  label22.caption := inttostr(g1c);
  label23.caption := inttostr(s1c);
  label24.caption := inttostr(g1d);
  label25.caption := inttostr(s1d);
  label26.caption := inttostr(g1e);
  label27.caption := inttostr(s1e);
 end;
end;

procedure loadedit(var g2a,g2b,g2c,g1a,s1a,g1b,s1b,g1c,s1c,g1d,s1d,g1e,s1e: integer);
begin
 with armv1fm do
 begin
  trackbar2.position := g2a;
  trackbar3.position := g2b;
  trackbar4.position := g2c;
  trackbar5.position := s1a;
  trackbar6.position := g1a;
  trackbar7.position := s1b;
  trackbar8.position := g1b;
  trackbar9.position := s1c;
  trackbar10.position := g1c;
  trackbar11.position := s1d;
  trackbar12.position := g1d;
  trackbar13.position := s1e;
  trackbar14.position := g1e;
 end;
  showedit;
 end;

function getmaxx: integer;
begin
 getmaxx := armv1fm.clientwidth;
end;

function getmaxy: integer;
begin
 getmaxy := armv1fm.clientheight;
end;

procedure setviewport(x1,y1,x2,y2: integer);
begin
 viewport := rect(x1,y1,x2,y2);
end;

procedure clearviewport;
begin
 with armv1fm.canvas do
 begin
  brush.color := clBackgnd;
  fillrect(viewport);
 end;
end;

procedure gotoxy(x,y: integer);
begin
 with armv1fm.canvas do
  moveto((x-1) * cwidth,(y-1) * leading);
end;

procedure outtextxy(x,y: integer; s: string);
begin
 setviewport(x,y,x + 33, y + 15);
 armv1fm.Canvas.fillrect(viewport);
 armv1Fm.canvas.textout(x,y,s);
end;

procedure outtextxy1(x,y: integer; s: string);
begin
 with armv1fm do
 begin
  canvas.font.color := clBlack;
  canvas.brush.color := clWhite;
  setviewport(x-4,y,x + 24, y + 15);
  canvas.fillrect(viewport);
  canvas.textout(x,y,s);
 end;
end;

procedure clrscr;
begin
 with armv1fm, canvas do
 begin
  setviewport(0,0,clientwidth, clientheight);
  clearviewport;
 end;
end;

procedure setwritemode(m: integer);
begin
 with  armv1fm.canvas do
 begin
  case m of
   0: pmode := pmCopy;
   1: pmode := pmXor;
   end;
  pen.mode := pmode;
 end;
end;

procedure setpencolor(c: integer);
begin
  case c of
   0: pcolor := clBackgnd;
   1: pcolor := clWrite;
   2: pcolor := clLime;
   end;
 armv1fm.canvas.pen.color := pcolor;
end;

procedure setbrushcolor(c: integer);
begin
  case c of
   0: bcolor := clBackgnd;
   1: bcolor := clWrite;
   2: bcolor := clLime;
   end;
 armv1fm.canvas.brush.color := bcolor;
end;

procedure setfontcolor(c: integer);
begin
  case c of
   0: fcolor := clBackgnd;
   1: fcolor := clWrite;
   end;
 armv1fm.canvas.font.color := pcolor;
end;

procedure textattr(c: byte);
begin
 case c of
  0: fcolor := clBackgnd;
  1: fcolor := clWrite;
 end;
end;

procedure drawpoly(n: integer; var v: poly2dtype);
var i: integer;
begin
 with armv1fm.canvas do
 begin
  pen.color := pcolor;
  for i := 1 to n do
   with v[i] do
    if i = 1 then moveto(x2d,y2d) else lineto(x2d,y2d);
 end;
end;

function wherex: integer;
begin
 with armv1fm.canvas do
  wherex := penpos.x div cwidth;
end;

function wherey: integer;
begin
 with armv1fm.canvas do
  wherey := penpos.y div leading;
end;

function readkey: byte;
var b: byte;
begin
 while not keyhit do ;
 keyhit := false;
 case inkey of
  VK_RIGHT: b := right;
  VK_LEFT:  b := left_;
  VK_UP:    b := Up;
  VK_DOWN:  b := Down;
  VK_PRIOR:  b := PgUp;
  VK_NEXT:  b := PgDn;
  VK_END:   b := EndKey;
  else b := inkey and 127;
 end;
 if b  < $7f then
   result := b or $20 // change to lower case
 else result := b;    // conform to TP def of special key
end;

procedure writelnstr(s: string);
var x,y: integer;
begin
 x := wherex; y := wherey;
 armv1fm.canvas.textout(x,y,s);
 with armv1fm.canvas do
 begin
  fillrect(rect(x,y,x+length(s)*cwidth,y + leading));
  textout(x,y,s);
 end;
 gotoxy(x,y+leading);
end;

procedure writestr(s: string);
var x,y: integer;
begin
 x := wherex; y := wherey;
 with armv1fm.canvas do
 begin
  fillrect(rect(x,y,x+length(s)*cwidth,y + leading));
  textout(x,y,s);
 end;
end;

procedure putpixel(x,y: integer; c: byte);
begin
 case c of
  0: pcolor := clBackgnd;
  1: pcolor := clWrite;
 end;
 with armv1fm,canvas do
 begin
  pen.color := pcolor;
  ellipse(rect(x-1,y-1,x+1,y+1));
 end;
end;

procedure TArmV1Fm.IdleLoop(Sender: TObject; var Done: boolean);
begin
 done := false;
 iterate;
 repeat
  queryperformancecounter(t2);
  application.ProcessMessages;
 until t2- t1 > freq div 44;
 t1 := t2;
end;

procedure TArmV1Fm.FormCreate(Sender: TObject);
begin
 application.OnIdle := idleloop;
 queryperformancecounter(t1);
 queryperformancefrequency(freq);
 initialize;
 with armv1fm, canvas do
 begin
  with SetTargPos, canvas do
  begin
   brush.color := clBlue;
   fillrect(rect(0,0,width,height));
   visible := true;
   font.Color := clWhite;
   textout(25,70,'CLICK-DRAG TARGET');
  end;
  with SetViewAngle, canvas do
  begin
   brush.color := clGray;
   fillrect(rect(0,0,width,height));
   visible := true;
   font.Color := clWhite;
   textout(16,70,'CLICK-DRAG VIEWPOINT');
  end;
  with panel1 do
  begin
   panel1.left := armv1fm.clientwidth - panel1.width - 20;
   panel1.top := armv1fm.clientheight - panel1.height - 20;
   trackbar1.min := -halfside div 3;
   trackbar1.max := round(1.5*halfside);
   trackbar1.position := round(1.0*halfside);
   TAz := trackbar1.position;
  end;
  cwidth := font.size;
  leading := cwidth + 4;
  pen.width := 2;
 end;
 panel2.visible := false;
 loaddiagram;
 stage := 0;
end;

procedure TArmV1Fm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   inkey := key;
   keyhit := true;
end;

procedure TArmV1Fm.RESETClick(Sender: TObject);
begin
 initialize;
end;

procedure TArmV1Fm.ExitButClick(Sender: TObject);
begin
 application.Terminate;
end;

procedure TArmV1Fm.setxypos(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
if ssleft in shift then
 with setviewangle, Canvas do
 if (X > 0) and (X < width) and
    (Y > 0) and (Y < height) then
 begin
//  TAx := -2*round(halfside*X/Width - halfside/2);
//  TAy := 2*round(-halfside*Y/height + halfside/2);
  r2b := -2*round(halfside*X/Width - halfside/2);
  r2a := 2*round(-halfside*Y/height + halfside/2);
 end;
end;

procedure TArmV1Fm.setViewpoint(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
if ssleft in shift then
 with setviewangle, Canvas do
 if (X > 0) and (X < width) and
    (Y > 0) and (Y < height) then
 begin
  Phi := -(2048 + round(X*4096/width - 2048));
  Theta := round(Y*4096/height - 2048);
 end;

end;

procedure TArmV1Fm.EditParazmsClick(Sender: TObject);
begin
 editing := not editing;
 panel2.visible := editing;
 stage := 2;
end;

procedure TArmV1Fm.TrackBar1Change(Sender: TObject);
begin
 TAz := Trackbar1.Position;
end;


procedure TArmV1Fm.TrackBar2Change(Sender: TObject);
begin
 g2a := trackbar2.position;
 showedit;
end;

procedure TArmV1Fm.TrackBar3Change(Sender: TObject);
begin
 g2b := trackBar3.position;
 showedit;
end;

procedure TArmV1Fm.TrackBar4Change(Sender: TObject);
begin
 g2c:= Trackbar4.position;
 showedit;
end;

procedure TArmV1Fm.TrackBar5Change(Sender: TObject);
begin
 g1a := Trackbar5.position;
 showedit;
end;

procedure TArmV1Fm.TrackBar6Change(Sender: TObject);
begin
 s1a := trackbar6.position;
 showedit;
end;

procedure TArmV1Fm.TrackBar7Change(Sender: TObject);
begin
 g1b := trackbar7.position;
 showedit;
end;

procedure TArmV1Fm.TrackBar8Change(Sender: TObject);
begin
 s1b := TrackBar8.position;
 showedit;
end;

procedure TArmV1Fm.TrackBar9Change(Sender: TObject);
begin
 g1c := trackbar9.position;
 showedit;
end;

procedure TArmV1Fm.TrackBar10Change(Sender: TObject);
begin
 s1c := TrackBar10.position;
 showedit;
end;

procedure TArmV1Fm.TrackBar11Change(Sender: TObject);
begin
 g1d := TrackBar11.position;
 showedit;
end;

procedure TArmV1Fm.TrackBar12Change(Sender: TObject);
begin
 s1d := TrackBar12.position;
 showedit;
end;

procedure TArmV1Fm.TrackBar13Change(Sender: TObject);
begin
 g1e := TrackBar12.Position;
 showedit;
end;

procedure TArmV1Fm.TrackBar14Change(Sender: TObject);
begin
 s1e := TrackBar14.position;
 showedit;
end;

procedure TArmV1Fm.saveparams(Sender: TObject; var Action: TCloseAction);
begin
 saveedit;
end;

begin
end.                                               i

